function Cmp09600_ConsultaEnvioAfFornecedor(General, ScreenService, MessageService, localStorageEngine, ZhFilterPreferences, templateManager, Utilities) {
    
    this.getCentralCompras = function(owner) {
        General.callRestEngine("cmp#/getCdFilCentCmp", "Row", {}).then(function(response) {
            setLocalVar('NMFILCENTCMP', response.dataset.data.NMFILCENTCMP);
            setLocalVar('CDFILCENTCMP', response.dataset.data.CDFILCENTCMP); 
            
            Utilities.startFilter(owner);
        }, function(error) {
			return MessageService.showMessageByCode(error.data ? 'cmp#' + error.data.error : 'Timeout', null, { type: 'ERROR' });
		});
    };
   
   this.limpaField = function(field, name) {
        if(field.name === 'NMGRUPFILI'){

            field.widget.getField(name).clearValue();
            field.widget.currentRow.NMFILDEST = '';
        }
   };
    
    this.setDsFilterApuracao = function(field) {
     
        let filterRow = field.widget.currentRow;
        
        let param = {
            "P_CDFILCENTCMP": getLocalVar("CDFILCENTCMP"),
            "P_IDCOINCDTAPU": filterRow.IDCOINCDTAPU,
            "P_DTAPURAAF_INI": filterRow.DTAPURAAF.start ? filterRow.DTAPURAAF.start : null,
            "P_DTAPURAAF_FIN": filterRow.DTAPURAAF.end ? filterRow.DTAPURAAF.end : null,
            "P_TDTAPURAAF": filterRow.DTAPURAAF.start && filterRow.DTAPURAAF.end ? null : 'T'
        };
        
        General.onClickDependentField(field, param);
        
    };
    
    this.openWidgetDetalhes = function(args) {
        var widget = args.owner.container.getWidget('WDGT_CONSULTA');
        ScreenService.openSwipe(widget);
        widget.activate();
        var row = widget.getParent().currentRow ;
        var cdfildest = args.owner.appliedFilter.FILTER_ROW.CDFILDEST.join('_');
         widget.dataSourceFilter = [
                {"name": "P_CDFILLANC",             "value": row.CDFILLANC,          "operator": "="},
                {"name": "P_ENVIO",                 "value": row.NRSEQENVIOAFORN ,   "operator": "="},
                {"name": "P_NRAPURPREC",            "value": row.NRAPURPREC,         "operator": "="},
                {"name": "P_CDFORNECED",            "value": row.CDFORNECED,         "operator": "="},
                {"name": "P_CDFILDEST",             "value": cdfildest,              "operator": "="}
            
        ]; 
        widget.reload();
    };    
    this.openTabbed = function(args) {
        var widget = args.owner.container.getWidget('tabbedWidget');
        var widgetProduto = args.owner.container.getWidget('WDGT_PRODUTO');
        var widgetUsuario = args.owner.container.getWidget('WDGT_USUARIO');
        var currentRowConsulta = widget.container.getWidget('WDGT_CONSULTA').currentRow;
        var currentRowAf = widget.container.getWidget('WDGT_CONSULTA_AF').currentRow;
        ScreenService.openSwipe(widget);
        var row = widget.container.getWidget('WDGT_CONSULTA').currentRow;
        var filterProduct = [
            {"name": "P_CDFILDEST",             "value": row.CDFILDEST ,        "operator": "="},
            {"name": "P_CDFILLANC",             "value": row.CDFILLANC,          "operator": "="},
            {"name": "P_NRAUTOFORN",            "value": row.NRAUTOFORN,         "operator": "="}
        ]; 
        var filterUser = [
            {"name": "P_CDFILDEST",             "value": currentRowConsulta.CDFILDEST ,         "operator": "="},
            {"name": "P_CDFILLANC",             "value": currentRowConsulta.CDFILLANC,          "operator": "="},
            {"name": "P_NRAUTOFORN",            "value": currentRowConsulta.NRAUTOFORN,         "operator": "="},
            {"name": "P_NRSEQENVIOAFORN",       "value": currentRowAf.NRSEQENVIOAFORN,    "operator": "="}
        ];
        widgetProduto.dataSourceFilter = angular.copy(filterProduct);
        widgetUsuario.dataSourceFilter = angular.copy(filterUser);
        widgetProduto.reload();
        widgetUsuario.reload();
        widget.activate();
    }; 
    this.createFilialFilter = function(fieldFilial){
        var fieldAgrupFili = fieldFilial.widget.getField('NMGRUPFILI');
        var widget = fieldFilial.widget;
        var row = {};
        row.CDOPERADOR = getLocalVar('CDOPERADOR');
        if(fieldAgrupFili.value()){
            row.CDGRUPFILI = widget.currentRow.CDGRUPFILI;
            row.FILTER_ALL_FILIAIS = null;
        } else {
            row.CDGRUPFILI = null;
            row.FILTER_ALL_FILIAIS = 'T';
        }
        
        fieldFilial.dataSourceFilter.forEach(function(filter){
            filter.value = row[filter.name];
        });
        fieldFilial.reload();
    };
    this.openFilter = function(widget){
        ZhFilterPreferences.openFilterWidget(widget).then(function(){
            var widgetFilter = templateManager.container.getActiveWidget();
            widgetFilter.newRow();
        });    
    };
    
    this.filtrar = function(args) {
  
        var widget = args.owner;
        var filterRow = args.e.preference.FILTER_ROW;

        widget.dataSourceFilter = [
            {"name": "P_CDFILCENTCMP",       "value": getLocalVar('CDFILCENTCMP'),                                                                     "operator": "="},
            {"name": "P_CDFILDEST",          "value": filterRow.CDFILDEST.join('_'),                                                                   "operator": "="},
            {"name": "P_CDFORNECED",         "value": filterRow.CDFORNECED && filterRow.CDFORNECED.length ? filterRow.CDFORNECED.join('_') : 'T',      "operator": "="},
            {"name": "P_CDOPERADOR",         "value": filterRow.CDOPERADOR && filterRow.CDOPERADOR.length ? filterRow.CDOPERADOR.join('_') : 'T',      "operator": "="},
            {"name": "P_CDCOMPRADOR",        "value": filterRow.CDCOMPRADOR && filterRow.CDCOMPRADOR.length ? filterRow.CDCOMPRADOR.join('_') : 'T',   "operator": "="},
            {"name": "P_NRAPURPRECO",        "value": filterRow.APURACAO && filterRow.APURACAO.length ? filterRow.APURACAO.join('_') : 'T',            "operator": "="},
            {"name": "P_SITUAF",             "value": filterRow.IDBAIXAAF.join('_'),                                                                   "operator": "="},
            {"name": "P_IDTCLASSENVAFOR",    "value": filterRow.CLASSENVAFOR.join('_'),                                                                "operator": "="},
            {"name": "P_DTAUTFINI",          "value": filterRow.DATA_AF.start ? filterRow.DATA_AF.start : null,                                        "operator": "="},
            {"name": "P_DTAUTFFIM",          "value": filterRow.DATA_AF.end ? filterRow.DATA_AF.end : null,                                            "operator": "="},
            {"name": "P_TDTAUTOFORN",        "value": filterRow.DATA_AF.start ? null : 'T',                                                            "operator": "="},
            {"name": "P_DTPROGINI",          "value": filterRow.DATA_ENTREGA.start ? filterRow.DATA_ENTREGA.start : null,                              "operator": "="},
            {"name": "P_DTPROGFIM",          "value": filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.end : null,                                  "operator": "="},
            {"name": "P_TDTPROGENTAF",       "value": filterRow.DATA_ENTREGA.start ? null : 'T',                                                       "operator": "="},
            {"name": "P_DTENVIOAF_INI",      "value": filterRow.DTENVIOAF.start ? filterRow.DTENVIOAF.start : null,                                    "operator": "="},
            {"name": "P_DTENVIOAF_FIN",      "value": filterRow.DTENVIOAF.end ? filterRow.DTENVIOAF.end : null,                                        "operator": "="},
            {"name": "P_TDTENVIOAF",         "value": filterRow.DTENVIOAF.start ? null : 'T',                                                          "operator": "="},
            {"name": "P_IDCOINCDTAPU",       "value": filterRow.IDCOINCDTAPU,                                                                          "operator": "="},
            {"name": "P_DTAPURAAF_INI",      "value": filterRow.DTAPURAAF.start ? filterRow.DTAPURAAF.start : null,                                    "operator": "="},
            {"name": "P_DTAPURAAF_FIN",      "value": filterRow.DTAPURAAF.end ? filterRow.DTAPURAAF.end : null,                                        "operator": "="},
            {"name": "P_TDTAPURAAF",         "value": filterRow.DTAPURAAF.start ? null : 'T',                                                          "operator": "="},
            {"name": "P_ENVIADO",            "value": filterRow.TIPO_ENVIO.indexOf('E') !== -1 ? 'S' : 'N',                                            "operator": "="},
            {"name": "P_RETORNADO",          "value": filterRow.TIPO_ENVIO.indexOf('R') !== -1 ? 'S' : 'N',                                            "operator": "="}
        ];
          
        widget.reload();
        
    };

    this.setDsFilterGridProduto = function (widget) {
        var row = widget.container.getWidget('WDGT_CONSULTA').currentRow ;
         widget.dataSourceFilter = [
                {"name": "P_CDFILDEST",             "value": row.CDFILDEST ,        "operator": "="},
                {"name": "P_CDFILLANC",             "value": row.CDFILLANC,          "operator": "="},
                {"name": "P_NRAUTOFORN",            "value": row.NRAUTOFORN,         "operator": "="}
            
        ]; 
        widget.reload();
    };
    this.setDsFilterGridUsuario = function (widget) {
        var currentRowConsulta = widget.container.getWidget('WDGT_CONSULTA').currentRow;
        var currentRowAf = widget.container.getWidget('WDGT_CONSULTA_AF').currentRow;
         widget.dataSourceFilter = [
                {"name": "P_CDFILDEST",         "value": currentRowConsulta.CDFILDEST , "operator": "="},
                {"name": "P_CDFILLANC",         "value": currentRowConsulta.CDFILLANC,  "operator": "="},
                {"name": "P_NRAUTOFORN",        "value": currentRowConsulta.NRAUTOFORN, "operator": "="},
                {"name": "P_NRSEQENVIOAFORN",   "value": currentRowAf.NRSEQENVIOAFORN,  "operator": "="}
        ]; 
        widget.reload();
    };
    this.setVazio = function(args) {
         args.e.preference.CUSTOM_FILTER_ROW = {};
    };    
    this.setStripe = function(widget){
      
        var filterRow = widget.appliedFilter.FILTER_ROW;
        var stripeRow = widget.container.getWidget('WDGT_STRIPE').currentRow;
        
        stripeRow.AGRUPFILI    = filterRow.NMGRUPFILI ? filterRow.NMGRUPFILI : "Todos";
        stripeRow.DTAUTOFORN   = filterRow && filterRow.DATA_AF && filterRow.DATA_AF.start && filterRow.DATA_AF.end ? filterRow.DATA_AF.start + " a " + filterRow.DATA_AF.end : "Todas";
        stripeRow.OPERADOR     = filterRow.NMOPERADOR ? filterRow.NMOPERADOR : "Todos";
        stripeRow.NMFILDESTINO = filterRow.NMFILDEST ? filterRow.NMFILDEST : "Todas";
        stripeRow.DTPROGENTAF  = filterRow && filterRow.DATA_ENTREGA && filterRow.DATA_ENTREGA.start && filterRow.DATA_ENTREGA.end ? filterRow.DATA_ENTREGA.start + " a " + filterRow.DATA_ENTREGA.end : "Todas";
        stripeRow.COMPRADOR    = filterRow.NMCOMPRADOR ? filterRow.NMCOMPRADOR : "Todos";
        
        widget._filterInfo = [
            {"label": ScreenService.i18n("Agrupamento de Unidades"), "value": stripeRow.AGRUPFILI},
            {"label": ScreenService.i18n("Unidade de Destino"), "value": stripeRow.DTAUTOFORN},    
            {"label": ScreenService.i18n("Data AF"), "value": stripeRow.OPERADOR},                 
            {"label": ScreenService.i18n("Dt. Entrega"), "value": stripeRow.NMFILDESTINO},         
            {"label": ScreenService.i18n("Operador"), "value": stripeRow.DTPROGENTAF},             
            {"label": ScreenService.i18n("Comprador"), "value": stripeRow.COMPRADOR}               
        ];
    };
    this.cancelReport = function(widget){
        ScreenService.closePopup();
        widget.container.getWidget('WDGT_CONSULTA_AF').activate();
    };
    this.corStatus = function(element, row){
        element.css('color', '#37943a');
    };
    
    this.openReport = function(args){
        var widget = args.owner.widget;
        if(widget.isValid()){
            var reportName = "CMP09600";
            
            General.openReportPopup(widget, this.abreRelatorio, [args, reportName]);
        }
    };
    
    this.abreRelatorio = function(args, reportName) {
        var row = angular.copy(args.row);
        var dataAf = !args.row.DATA_AF.start ? false : true;
        var dataEntrega = !args.row.DATA_ENTREGA.start ? false : true;
        
        row.__report_name = reportName;
        row.P_CDFILICENTCOMP = getLocalVar('CDFILCENTCMP');
        row.P_CDGRUPFILI = 'T';
        row.L_FILIAL = args.row.NMFILDEST.join('_');
        row.L_FORNECEDOR = args.row.CDFORNECED && args.row.CDFORNECED.length ? args.row.CDFORNECED.join('_') : 'T';
        row.L_COMPRADOR = args.row.NMCOMPRADOR && args.row.NMCOMPRADOR.length ? args.row.NMCOMPRADOR.join('_') : 'T';
        row.P_DTINICIALAF = dataAf ? args.row.DATA_AF.start : null;
        row.P_DTFINALAF = dataAf ? args.row.DATA_AF.end : null;
        row.P_TDTAF = dataAf ? null : 'T';
        row.P_DTENTREGAINI = dataEntrega ? args.row.DATA_ENTREGA.start : null;
        row.P_DTENTREGAFIN = dataEntrega ? args.row.DATA_ENTREGA.end : null;
        row.P_TDTENTREGA = dataEntrega ? null : 'T';
        row.P_ENVIADA = args.row.STATUS.indexOf("E") !== -1 ? 'S' : 'N' ;
        row.P_RETORNADA = args.row.STATUS.indexOf("R") !== -1 ? 'S' : 'N' ;
        row.QR2TYPE = args.row.QR2TYPE;
          
        General.openReport('cmp_fornecimento_autorizacaoFornecimento#/consultaEnvioReport', reportName, row);
    };
    
    this.openReportWidget = function(widget){
        var reportWidget = widget.container.getWidget('WDGT_REPORT');
        reportWidget.newRow();
        ScreenService.openPopup(reportWidget);
    };
            
}

Configuration(function(ContextRegister) {
    ContextRegister.register('Cmp09600_ConsultaEnvioAfFornecedor', Cmp09600_ConsultaEnvioAfFornecedor);
});
